#include "affine.h"
#include "paramfile.h"
#include "util.h"

ParamList* cp;

void setAffineParams(ParamList* params) {
	cp = params;
}

void computeAffine(int* picdata, int w, int h) {
	double x,y,xn,yn;
	int xt,yt;
	int i;
	Param curp;

	x = RANDDBL(cp->xmin, cp->xmax);
	y = RANDDBL(cp->ymin, cp->ymax);

	ParamList_print(cp);

	for (i = 0; i < 0xffff; ++i) {
		if (RAND1() < 0.5) {
			curp = cp->paramarr[0];
		} else {
			curp = cp->paramarr[1];
		}

		xn = curp.a * x + curp.c * y + curp.e;
		yn = curp.b * x + curp.d * y + curp.f;

		//plot!
		xt = (int) ((xn - cp->xmin) / (cp->xmax - cp->xmin) * w);
		yt = (int) ((yn - cp->ymin) / (cp->ymax - cp->ymin) * h);

		if (xt < w && xt > 0 && yt < h && yt > 0) {
			picdata[yt*w + xt] += 0xfffff;
		}
		x = xn;
		y = yn;
	}
}

/*
void computeAffine(int* picdata, int w, int h) {
	int x, y;

	for (x = 0; x < w; ++x) {
		for (y = 0; y < h; ++y) {
			picdata[y*w + x] = 0xffffffff;
		}
	}
}
*/