#ifndef PARAMFILE_H_
#define PARAMFILE_H_

#ifdef __cplusplus
extern "C" {
#endif

#define _CRT_SECURE_NO_DEPRECATE
#define MAX_PARAM_LEN 10

typedef struct {
	double a, b, c, d, e, f, p;
} Param;

typedef struct {
	Param* paramarr;
	int paramlen;
	double xmin, xmax, ymin, ymax;
} ParamList;

typedef struct {
	float	a1, b1, c1, d1, e1, f1,
			a2, b2, c2, d2, e2, f2;
	float	xmin, xmax, ymin, ymax;
} GPUParams;

typedef struct {
	ParamList** tweenarr;
	int tweenlen;
	int tweensteps;
	int curstep;
	ParamList* buf;
} ParamTween;

ParamList* ParamList_init();
void ParamList_load(ParamList* plst, const char* fname);
void ParamList_print(ParamList* plst);
GPUParams getGPUParams(ParamList* plst);
void GPUParams_print(GPUParams p);

ParamTween* ParamTween_init();
void ParamTween_load(ParamTween* ptw, const char** fnames, int fnameslen, int tweensteps);
ParamList* ParamTween_cur(ParamTween* ptw);
void ParamTween_increment(ParamTween* ptw);

#ifdef __cplusplus
}
#endif

#endif