#include "fileio.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#define MAX_IFS_FILES 1000
#define MAX_IFS_FILELEN 1024

char* getStartupDir(char* argv0) {
	char* out = (char*) malloc(strlen(argv0)*sizeof(char));
	char* lastloc = NULL;
	strcpy(out, argv0);

	//find the last backslash
	lastloc = strrchr(out,'\\');

	if (lastloc == NULL) {
		printf("Error: could not determine startup directory from %s\n", out);
	} else {
		*lastloc = '\0';
	}

	return out;
}

StringList getFilenamesFromFile(char* dirname, char* fname) {
	StringList lst;
	char** fnames = (char**) malloc(sizeof(char*)*MAX_IFS_FILES);
	char* buf1 = (char*) malloc(sizeof(char)*MAX_IFS_FILELEN);
	char* buf2 = (char*) malloc(sizeof(char)*MAX_IFS_FILELEN);
	char* tmpptr;
	FILE* fin;
	int x = 0;

	strcpy(buf1, dirname);
	strcat(buf1, "\\");
	strcat(buf1, fname);

	fin = fopen(buf1, "r");

	if (fin == NULL) {
		printf("Error: could not open file list in %s\n", fname);
		return lst;
	}

	while (!feof(fin)) {
		//get individual names from the file
		fgets(buf1, MAX_IFS_FILELEN, fin);
		if ((tmpptr = strchr(buf1, '\n')) != NULL) {
			*tmpptr = '\0';
		}
		
		//append to the directory name
		strcpy(buf2, dirname);
		strcat(buf2, "\\");
		strcat(buf2, buf1);

		//create a pointer in fnames
		fnames[x] = (char*) malloc(sizeof(char)*(strlen(buf2)+1));
		strcpy(fnames[x], buf2);

		++x;
	}

	lst.strings = fnames;
	lst.len = x;

	return lst;
}