#Create a new project file from the Blank project.
#Ilari Shafer, 11/23/08

import sys
import os

def usage():
	print "Usage: python newproj.py [name]"

#Copy the file located at _fr_ to _to_
#	Apply the function fn to the contents of the file
def copyApply(fr,to,fn):
	f = open(fr,"r")
	fcont = ""
	try:
		fcont = f.read()
	except:
		print "Error reading file contents from %s" % (fr)
	finally:
		f.close()
		
	contnew = fn(fcont)
	
	fo = open(to, "w")
	try:
		fo.write(contnew)
	except:
		print "Error writing file contents to %s" % (to)
	finally:
		fo.close()

if __name__ == '__main__':
	if len(sys.argv) != 2:
		usage()
		sys.exit(1)

	tdir = sys.argv[1]
	
	if (os.path.exists(tdir)):
		print "A directory named %s already exists; aborting." % tdir
		sys.exit(1)
	
	os.mkdir(tdir)
	
	#Copy the solution file
	#HACK: this doesn't deal with the GUIDs in the .sln file properly.
	copyApply("Blank/blank.sln", "%s/%s.sln" % (tdir, tdir), \
		lambda s: s.replace("blank",tdir) \
		)
	
	#Copy the vcproj
	copyApply("Blank/blank.vcproj", "%s/%s.vcproj" % (tdir, tdir), \
		lambda s: s.replace("blank", tdir) \
		)
	
	#Copy the .cu file
	copyApply("Blank/blank.cu", "%s/%s.cu" % (tdir, tdir), \
		lambda s: s \
		)
